; TLC1543a.asm - 10 Bit 12 Chanell AD-Converter
; Anschluss an Port 0

ADPort                     :equ 00h     ; SysPort0
ADMaskBits                 :equ 1fh     ;
ADEOC                      :equ 01h     ; P0.0
ADClock                    :equ 02h     ; P0.1
ADDataIn                   :equ 04h     ; P0.2
ADDataOut                  :equ 08h     ; P0.3
ADCS                       :equ 10h     ; P0.4

gbADChan                   :equ 31h     ;
gbADPortMirror             :equ 32h     ;
gbADBitcount               :equ 33h     ;
gbADChanIn                 :equ 34h     ; 
gbADDatHi                  :equ 78h     ;USBEndP1FIFO
gbADDatLo                  :equ 79h     ;USBEndP1FIFO +1

;//$PAGE
;*******************************************************************************
; ADRead()
; 
;*******************************************************************************

  ADRead:
    mov  a,[gbADChanIn]		;read analog input
    mov  [gbADChan],a
    mov  a,[gbPort0]		; setup port bits
    and  a,~ADClock
    or   a,(ADDataOut|ADCS|ADEOC)
    iowr ADPort
    mov  [gbADPortMirror],a
    mov  a,00h
    mov  [gbADDatHi],a
    mov  [gbADDatLo],a
    mov  a,[gbADPortMirror]	;CS low
    and  a,~ADCS
    iowr ADPort
    mov  [gbADPortMirror],a
    mov  a,8  		    	;8 bits count
  ADLoop1:
    mov  [gbADBitcount],a  
    mov  a,[gbADDatHi]		;output data shift left
    asl  a
    mov  [gbADDatHi],a
    iord ADPort 	    	;read one Bit from Dout
    and  a,ADDataOut
    cmp  a,ADDataOut
    jnz  Ainlow1
    mov  a,[gbADDatHi]
    or   a,01h
    mov  [gbADDatHi],a
  Ainlow1:
    mov  a,[gbADPortMirror]  	;output one bit to Din
    and  a,~ADDataIn
    mov  [gbADPortMirror],a
    mov  a,[gbADChan]    
    and  a,80h
    cmp  a,80h
    jnz  AoutLow
    mov  a,[gbADPortMirror]
    or   a,ADDataIn
    mov  [gbADPortMirror],a
  AoutLow:
    mov  a,[gbADPortMirror]
    iowr ADPort
    or   a,ADClock		; set clock high
    iowr ADPort
    mov  a,[gbADChan]    	;input data shift left
    asl  a 
    mov  [gbADChan],a    
    nop
    nop
    nop
    nop
    mov  a,[gbADPortMirror]
    and  a,~ADClock		; set clock low
    iowr ADPort
    mov  [gbADPortMirror],a
    mov  a,[gbADBitcount]	; complete loop 1
    dec  a
    jnz  ADLoop1
				; read the two bytes left
    mov  a,02h
   ADLoop2:
    mov  [gbADBitcount],a  
    mov  a,[gbADDatLo]		;output data shift left
    asl  a
    mov  [gbADDatLo],a
    iord ADPort			;read one Bit from Dout
    and  a,ADDataOut
    cmp  a,ADDataOut
    jnz  Ainlow2
    mov  a,[gbADDatLo]
    or   a,01h
    mov  [gbADDatLo],a
  Ainlow2:
    mov  a,[gbADPortMirror]	;set clock high
    or   a,ADClock
    iowr ADPort
    nop
    nop
    nop
    nop
    and  a,~ADClock 		;set clock low
    iowr ADPort
    mov  [gbADPortMirror],a
    mov  a,[gbADBitcount]	;complete loop 2
    dec  a
    jnz  ADLoop2
    mov  a,[gbADPortMirror]	;set CS high
    or   a,ADCS
    iowr ADPort
    ret


