;; TLC1543d.asm - 10 Bit 12 Chanell AD-Converter
; 3.5. NOPs eingefgt ...

ADPort                     :equ 01h     ; SysPort1
ADMaskBits                 :equ 1fh     ;
;  ADEOC                      :equ 01h     ; P0.0
ADClock                    :equ 01h     ; P0.0
ADDataIn                   :equ 02h     ; P0.1
ADDataOut                  :equ 04h     ; P0.2
ADCS                       :equ 08h     ; P0.3

gbADChan                   :equ 31h     ;
gbADPortMirror             :equ 32h     ;
gbADBitcount               :equ 33h     ;
gbADChanIn                 :equ 34h     ; 
gbADDatHi                  :equ 35h     ;
gbADDatLo                  :equ 36h     ;
gbDIn			   :equ 37h
gbToggle                   :equ 38h


;*******************************************************************************
; ADRead()  Toggle analog and digital inputs
;*******************************************************************************

  ADDRead:
    mov  a,[gbToggle]
    cmp  a,1
    jnz  Digi
  Ann:
    call ADRead
    mov  a,0
    mov  [gbToggle],a
    ret
  Digi:
    call RdDin
    mov  a,1
    mov  [gbToggle],a
    ret
  
;*******************************************************************************
; ADRead()  Read 4 inputs gBADChan/+1/+2/+3
;*******************************************************************************

  ADRead:
    mov  a,[gbADChanIn]		;read analog input base
    add  a,48			;Base + 3
    mov  [gbADChan],a
    call ADC

    mov  a,[gbADChanIn]		;read analog input
    add  a,32			;convert (base+2)
    mov  [gbADChan],a
    call ADC
    mov  a,[gbADDatHi]		;result (base +3)
    mov  [7Eh],a
    mov  a,[gbADDatLo]
    mov  [7Fh],a

    mov  a,[gbADChanIn]		;read analog input
    add  a,16			;convert (base+1)
    mov  [gbADChan],a
    call ADC
    mov  a,[gbADDatHi]		;result (base +2)
    mov  [7Dh],a
    mov a,[7Fh]
    asl  a
    asl  a
    asl  a
    asl  a
    add  a,[gbADDatLo]
    mov  [7Fh],a

    mov  a,[gbADChanIn]		;read analog input
    mov  [gbADChan],a           ;convert (base)
    call ADC
    mov  a,[gbADDatHi]		;result (base +1)
    mov  [7Bh],a
    mov  a,[gbADDatLo]
    mov  [7Ch],a

    mov  a,[gbADChanIn]		;read analog input
    mov  [gbADChan],a           ;convert (base)
    call ADC
    mov  a,[gbADDatHi]		;result (base)
    mov  [7Ah],a
    mov a,[7Ch]
    asl  a
    asl  a
    asl  a
    asl  a
    add  a,[gbADDatLo]
    mov  [7Ch],a
    ret

  ADC:
    mov  a,[gbPort0]		; setup port bits
    and  a,~ADClock
    or   a,(ADDataOut|ADCS)
    iowr ADPort
    mov  [gbADPortMirror],a
    mov  a,00h
    mov  [gbADDatHi],a
    mov  [gbADDatLo],a
    mov  a,[gbADPortMirror]	;CS low
    and  a,~ADCS
    iowr ADPort
    mov  [gbADPortMirror],a
    mov  a,8  		    	;8 bits count
  ADLoop1:
    mov  [gbADBitcount],a  
    mov  a,[gbADDatHi]		;output data shift left
    asl  a
    mov  [gbADDatHi],a
    iord ADPort 	    	;read one Bit from Dout
    and  a,ADDataOut
    cmp  a,ADDataOut
    jnz  Ainlow1
    mov  a,[gbADDatHi]
    or   a,01h
    mov  [gbADDatHi],a
  Ainlow1:
    mov  a,[gbADPortMirror]  	;output one bit to Din
    and  a,~ADDataIn
    mov  [gbADPortMirror],a
    mov  a,[gbADChan]    
    and  a,80h
    cmp  a,80h
    jnz  AoutLow
    mov  a,[gbADPortMirror]
    or   a,ADDataIn
    mov  [gbADPortMirror],a
  AoutLow:
    mov  a,[gbADPortMirror]
    iowr ADPort
    nop
    nop
    or   a,ADClock		; set clock high
    iowr ADPort
    nop
    nop
    mov  a,[gbADChan]    	;input data shift left
    asl  a 
    mov  [gbADChan],a    
    mov  a,[gbADPortMirror]
    and  a,~ADClock		; set clock low
    iowr ADPort
    mov  [gbADPortMirror],a
    mov  a,[gbADBitcount]	; complete loop 1
    dec  a
    jnz  ADLoop1
				; read the two bytes left
    mov  a,02h
   ADLoop2:
    mov  [gbADBitcount],a  
    mov  a,[gbADDatLo]		;output data shift left
    asl  a
    mov  [gbADDatLo],a
    iord ADPort			;read one Bit from Dout
    and  a,ADDataOut
    cmp  a,ADDataOut
    jnz  Ainlow2
    mov  a,[gbADDatLo]
    or   a,01h
    mov  [gbADDatLo],a
  Ainlow2:
    mov  a,[gbADPortMirror]	;set clock high
    or   a,ADClock
    iowr ADPort
    nop
    nop
    nop
    nop
    and  a,~ADClock 		;set clock low
    iowr ADPort
    mov  [gbADPortMirror],a
    mov  a,[gbADBitcount]	;complete loop 2
    dec  a
    jnz  ADLoop2
    mov  a,[gbADPortMirror]	;set CS high
    or   a,ADCS
    iowr ADPort
    nop
    nop
    nop
    nop
    nop
    nop  ;4us

    nop
    nop
    nop
    nop
    nop
    nop  ;4us

    nop
    nop
    nop
    nop
    nop
    nop  ;4us

    nop
    nop
    nop
    nop
    nop
    nop  ;4us

    nop
    nop
    nop
    nop
    nop
    nop  ;4us
    ret

;*******************************************************************************
; ADRead()  Read Ch0...7 as Digital Input
;*******************************************************************************

  RdDin:
    mov A,7
    mov [gbADChan],a
    call ADC2 			;convert ch7

    mov A,0
    mov [gbADDatHi],a		;clear data
    mov A,6
    mov  [gbADChan],a
    call ADC2			;read ch7
    mov  a,[gbADDatHi]
    asl  a
    mov  [gbADDatHi],a

    mov A,5
    mov  [gbADChan],a
    call ADC2			;read ch6
    mov  a,[gbADDatHi]
    asl  a
    mov  [gbADDatHi],a

    mov A,4
    mov  [gbADChan],a
    call ADC2			;read ch5
    mov  a,[gbADDatHi]
    asl  a
    mov  [gbADDatHi],a

    mov A,3
    mov  [gbADChan],a
    call ADC2			;read ch4
    mov  a,[gbADDatHi]
    asl  a
    mov  [gbADDatHi],a

    mov A,2
    mov  [gbADChan],a
    call ADC2			;read ch3
    mov  a,[gbADDatHi]
    asl  a
    mov  [gbADDatHi],a

    mov A,1
    mov  [gbADChan],a
    call ADC2			;read ch2
    mov  a,[gbADDatHi]
    asl  a
    mov  [gbADDatHi],a

    mov A,0
    mov  [gbADChan],a
    call ADC2			;read ch1
    mov  a,[gbADDatHi]
    asl  a
    mov  [gbADDatHi],a

    mov A,0
    mov  [gbADChan],a
    call ADC2			;read ch0
    mov  a,[gbADDatHi]
    mov  [gbDIn],a
    mov  [79h],a
    ret
  

   ADC2:
    mov  a,[gbPort0]		; setup port bits
    and  a,~ADClock
    or   a,(ADDataOut|ADCS)
    iowr ADPort
    mov  [gbADPortMirror],a
    mov  a,[gbADPortMirror]	;CS low
    and  a,~ADCS
    iowr ADPort
    nop
    nop
    nop
    mov  [gbADPortMirror],a
    iord ADPort 	    	;read MSB Dout
    and  a,ADDataOut
    cmp  a,ADDataOut
    jnz  Ainlow3
    mov  a,[gbADDatHi]
    or   a,01h
    mov  [gbADDatHi],a
  Ainlow3:

    mov  a,4  		    	;4 bits count
  ADLoop3:
    mov  [gbADBitcount],a  
    mov  a,[gbADPortMirror]  	;output one bit to Din
    and  a,~ADDataIn
    mov  [gbADPortMirror],a
    mov  a,[gbADChan]    
    and  a,08h
    cmp  a,08h
    jnz  AoutLow2
    mov  a,[gbADPortMirror]
    or   a,ADDataIn
    mov  [gbADPortMirror],a
  AoutLow2:
    mov  a,[gbADPortMirror]
    iowr ADPort
    nop
    nop
    or   a,ADClock		; set clock high
    iowr ADPort
    mov  a,[gbADChan]    	;input data shift left
    asl  a 
    mov  [gbADChan],a    
    mov  a,[gbADPortMirror]
    and  a,~ADClock		; set clock low
    iowr ADPort
    mov  [gbADPortMirror],a
    mov  a,[gbADBitcount]	; complete loop 1
    dec  a
    jnz  ADLoop3
				; read the two bytes left
    mov  a,08h
   ADLoop4:
    mov  [gbADBitcount],a
    mov  a,[gbADPortMirror]	;set clock high
    or   a,ADClock
    iowr ADPort
    nop
    nop 
    nop
    nop
    and  a,~ADClock 		;set clock low
    iowr ADPort
    mov  [gbADPortMirror],a
    mov  a,[gbADBitcount]	;complete loop 2
    dec  a
    jnz  ADLoop4
    mov  a,[gbADPortMirror]	;set CS high
    or   a,ADCS
    iowr ADPort
    nop
    nop
    nop
    nop
    nop
    nop  ;4us

    ret


